﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using IDTechSDK;
namespace KioskIIIDemo
{
    class DeviceTerminalInfo
    {
        //const message ID


        public const int MSC_ID_PROCESS_WAIT = 0x11;

        public const int MSC_ID_WELCOME = 0x23;

        public const int MSC_ID_AMOUNT = 0x01;
        public const int MSC_ID_AMOUNT_OTHER = 0x24;

        public const int MSC_ID_CANCELLED = 0x21;
        public const int MSC_ID_CANCEL_OR_ENTER = 0x05;

        public const int MSC_ID_ENTER_AMOUNT = 0x08;
        public const int MSC_ID_ENTER_AMOUNT_OTHER = 0x25;
        public const int MSC_ID_ENTER_PIN = 0x09;

        public const int MSC_ID_SWIPE_OR_INSERT = 0x0B;
        public const int MSC_ID_TIME_OUT = 0x19;
        public const int MSC_ID_TERMINATE = 0x17;
        public const int MSC_ID_USE_CHIP_READER = 0x0E;
        public const int MSC_ID_APPROVED = 0x03;
        public const int MSC_ID_TRY_AGAIN = 0x14;
        public const int MSC_ID_CAPK_HASH_VALUE_FAIL = 0x26;


        public static string terminalLanguage = "";
        public static string merchantName = "";
        public static string merchantID = "";
        public static string terminalID = "";

        public static string transType = "";
        public static string amount = "";
        public static int exponent = 2;
        public static string transDate = "";
        public static string transTime = "";


        public static void initialTerminal(bool emvICC)
        {
            byte[] tlv = null;
            RETURN_CODE rt = 0;
            Common.pause(300);
            if (emvICC==true) rt = IDT_Device.SharedController.emv_retrieveTerminalData(ref tlv);
            else rt = IDT_Device.SharedController.ctls_retrieveTerminalData(ref tlv);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                string hexValueTerminalLanguage = IDTechTools.getASCIIArrayTagFromTLVs(tlv,"df10");
                if (hexValueTerminalLanguage.Length > 1)   terminalLanguage = hexValueTerminalLanguage.Substring(0, 2);
                System.Diagnostics.Debug.WriteLine("Retrieve Terminal Successful");
                merchantName = IDTechTools.getASCIIArrayTagFromTLVs(tlv, "9F4E");
                merchantID = IDTechTools.getASCIIArrayTagFromTLVs(tlv, "9F16");
                terminalID = IDTechTools.getASCIIArrayTagFromTLVs(tlv, "9F1C");
                string exp = IDTechTools.getHexArrayTagFromTLVs(tlv, "5F36");
                if(exp.Length>0)
                    exponent = Int32.Parse(IDTechTools.getHexArrayTagFromTLVs(tlv, "5F36"));
            }
            else
            {
                System.Diagnostics.Debug.WriteLine("Retrieve Terminal failed Error Code: " + "0x" + String.Format("{0:X}", (ushort)rt));
            }




        }

        public static void setLanguage(byte[] language)
        {
            ASCIIEncoding encoding = new ASCIIEncoding();
            terminalLanguage = encoding.GetString(language, 0, 2);
        }
        public static void setLanguage(string language)
        {
            terminalLanguage = language;
        }
        public static string getDisplayMessage(int id)
        {
            if (id == 0x15)
            {
                int ssss = 0;
                ssss = 2;
            }
            //english
            if (String.Compare(terminalLanguage, "en", true) == 0)
                return languageEN[id];
            //french
            else if (String.Compare(terminalLanguage, "fr", true) == 0)
                return languageFR[id];
            //spanish
            else if (String.Compare(terminalLanguage, "sp", true) == 0 || String.Compare(terminalLanguage, "es", true) == 0)
                return languageSP[id];
            //chinese
            else if (String.Compare(terminalLanguage, "zh", true) == 0)
                return languageZH[id];
            else
                return languageEN[id];

        }
        public static string  getLanguageCode(string sLanguage)
        {
            if (String.Compare(sLanguage, "es", true) == 0)
                sLanguage = "sp";

            if (String.Compare(sLanguage, "en", true) == 0)
            {
                terminalLanguage = sLanguage;
                return "ENGLISH";
            }
            else if (String.Compare(sLanguage, "fr", true) == 0)
            {
                terminalLanguage = sLanguage;
                return "FRANCAIS";
            }
            else if (String.Compare(sLanguage, "sp", true) == 0 || String.Compare(sLanguage, "es", true) == 0)
            {
                terminalLanguage = sLanguage;
                return "ESPANOL";
            }
            else if (String.Compare(sLanguage, "zh", true) == 0)
            {
                terminalLanguage = sLanguage;
                return "中文";
            }
            else
             return  "(Unsupported)";
        }
        public static string getDisplayMessage(byte[] language, int id)
        {
            ASCIIEncoding encoding = new ASCIIEncoding();
            string sLanguage = encoding.GetString(language, 0, 2);
            if (String.Compare(sLanguage, "en", true) == 0)
            {
                terminalLanguage = sLanguage;
                return languageEN[id];
            }
            else if (String.Compare(sLanguage, "fr", true) == 0)
            {
                terminalLanguage = sLanguage;
                return languageFR[id];
            }
            else if (String.Compare(sLanguage, "sp", true) == 0 || String.Compare(sLanguage, "es", true) == 0)
            {
                terminalLanguage = sLanguage;
                return languageSP[id];
            }
            else if (String.Compare(sLanguage, "zh", true) == 0)
            {
                terminalLanguage = sLanguage;
                return languageZH[id];
            }
            else
            {
                terminalLanguage = "en";
                return languageEN[id];
            }

        }
        static string[] languageEN = { "","AMOUNT",
                                "AMOUNT OK ? ",
                                "APPROVED",
                                "CALL YOUR BANK",
                                "CANCEL OR ENTER",
                                "CARD ERROR",
                                "DECLINED",
                                "ENTER AMOUNT",
                                "ENTER PIN:",
                                "INCORRECT PIN",
                                "SWIPE OR INSERT",
                                "CARD",
                                "INSERT CARD",
                                "USE CHIP READER",
                                "NOT ACCEPTED",
                                "GET PIN OK",
                                "PLEASE WAIT...",
                                "PROCESSING ERROR",
                                "USE MAGSTRIPE",
                                "TRY AGAIN",
                                "GO ONLINE",
                                "TRANSACTION ERR",
                                "TERMINATE",
                                "ADVICE",
                                "TIME OUT",
                                "PROCESSING...",
                                "PIN TRY LIMIT EX",
                                "ISSUER AUTH FAIL",
                                "CONTINUE PROCESS",
                                "GET PIN ERROR",
                                "GET PIN FAIL",
                                "NO KEY GET PIN",
                                "CANCELLED",
                                "LAST PIN TRY",
                                "WELCOME",
                                "AMOUNT OTHER",
                                "ENTER AMOUNT OTHER",
                                "CAPK HASH VALUE FAIL"};

        static string[] languageFR = { "","MONTANT",
                                "MONTANT OK?",
                                "APPROUVE",
                                "APPE VOTRE BANQE",
                                "ANNULE OU ENTRER",
                                "ERREUR CARTE",
                                "REFUSE",
                                "ENTREZ MONTANT",
                                "ENTREZ PIN:",
                                "NIP INCORRECT",
                                "PASSER OU INSERT",
                                "CARTE",
                                "INSERT CARTE",
                                "UTI LECTEUR CHIP",
                                "PAS ACCEPTE",
                                "CODE OK",
                                "ATTENDRE...",
                                "ERREUR DE TRAITE",
                                "USE MAGSTRIPE",
                                "REESSAYER",
                                "GO LIGNE",
                                "ERREUR DE TRANS",
                                "RESILIER",
                                "CONSEILS",
                                "TIMEOUT",
                                "PROCESSUS...",
                                "PIN TRY DEPASSE",
                                "EMETTEUR FAIL",
                                "CONTINUER LA",
                                "GET PIN ERROR",
                                "GET PIN FAIL",
                                "NO KEY GET PIN",
                                "ANNULE",
                                "LAST PIN TRY",
                                "BIENVENUE",
                                "MONTANT AUTRES",
                                "ENTRER MONTANT AUTRES",
                                "CAPK HASH VALEUR FAIL" };
        static string[] languageSP = { "", "CANTIDAD",
                                "MONTO ES CORRECTO?",
                                "APROVADO",
                                "LLAME A SU BANCO",
                                "CANCELAR O ENTRAR",
                                "ERROR DE TARJETA",
                                "DECLINADO",
                                "INGRESE MONTO",
                                "ENTRAR NPI:",
                                "NPI INCORRECTO",
                                "MOVER O INSERT",
                                "TARJETA",
                                "INSERTAR TARJETA",
                                "USO CHIP  LECTOR",
                                "NO ACEPTADO",
                                "PIN ACEPTADO",
                                "POR FAVOR ESPERE",
                                "ERROR PROCESANDO",
                                "USO DE MAGSTRIPE",
                                "VUELV INTENTARLO",
                                "GO LINEA",
                                "ERROR DE TRANSAC",
                                "TERMINAR",
                                "CONSEJOS",
                                "TIEMPO DE ESPERA",
                                "PROCESANDO...",
                                "TRY PIN SUPERADA",
                                "EMISOR FALLA",
                                "CONTINUAR PROCES",
                                "OBTENER PIN ERR",
                                "OBTENER PIN FALL",
                                "NO CLAVE GET PIN",
                                "CANCELADO",
                                "LAST PIN TRY",
                                "BIENVENIDOS",
                                "IMPORTE OTRAS",
                                "ENTRAR IMPORTE OTRAS",
                                "CAPK HASH VALOR FAIL"  };

        static string[] languageZH = { "", 
                                "金额",
                                "确定金额?",
                                "通过",
                                "请联系您的银行",
                                "取消或确定",
                                "读卡错误",
                                "卡被拒",
                                "输入金额",
                                "请输入密码:",
                                "密码错误",
                                "请刷卡或插卡",
                                "卡",
                                "请插卡",
                                "使用芯片卡",
                                "无法接受",
                                "获取密码正确",
                                "等候中",
                                "处理错误",
                                "使用磁条卡",
                                "请重试",
                                "在线",
                                "交易错误",
                                "终止",
                                "建议",
                                "超时",
                                "处理中...",
                                "密码尝试次数过多",
                                "与发卡机构认证",
                                "继续处理",
                                "密码错误",
                                "获取密码错误",
                                "无法输入密码",
                                "取消",
                                "最后一次输入密码",
                                "欢迎使用",
                                "返现",
                                "输入返现",
                                "公钥哈希值错误"
        };

    }
}
